<h1>Product
  <span *ngIf="productForm.get('id').value !== null">edit</span>
  <span *ngIf="productForm.get('id').value === null">create</span>
</h1>
<br>
<form [formGroup]="productForm">
  <div class="form-group row" *ngIf="productForm.get('id').value !== null">
    <label for="staticId" class="col-sm-2 col-form-label">ID</label>
    <div class="col-sm-10">
      <input type="text" readonly nbInput fullWidth id="staticId" formControlName="id">
    </div>
  </div>
  <div class="form-group row">
    <label for="inputName" class="col-sm-2 col-form-label">Product Name</label>
    <div class="col-sm-10">
      <input type="text" nbInput fullWidth id="inputName" formControlName="name"
             [ngClass]="{'is-invalid':!productForm.get('name').valid}"
             [status]="productForm.get('name').touched && !productForm.get('name').valid ? 'danger' : 'basic'">
      <div class="invalid-feedback" *ngFor="let err of productForm.get('name').getError('backendErrors')">
        {{err}}
      </div>
    </div>
  </div>
  <div class="form-group row">
    <label for="inputPrice" class="col-sm-2 col-form-label">Price</label>
    <div class="col-sm-10">
      <input type="number" nbInput fullWidth id="inputPrice" formControlName="price"
             [ngClass]="{'is-invalid':!productForm.get('price').valid}"
             [status]="productForm.get('price').touched && !productForm.get('price').valid ? 'danger' : 'basic'">
      <div class="invalid-feedback" *ngFor="let err of productForm.get('price').getError('backendErrors')">
        {{err}}
      </div>
    </div>
  </div>
  <div class="form-group row">
    <label for="inputDescription" class="col-sm-2 col-form-label">Description</label>
    <div class="col-sm-10">
      <input type="text" nbInput fullWidth id="inputDescription" formControlName="description"
             [ngClass]="{'is-invalid':!productForm.get('description').valid}"
             [status]="productForm.get('description').touched && !productForm.get('description').valid ? 'danger' : 'basic'">
      <div class="invalid-feedback" *ngFor="let err of productForm.get('description').getError('backendErrors')">
        {{err}}
      </div>
    </div>
  </div>
  <div class="form-group row">
    <label for="selectProductType" class="col-sm-2 col-form-label">Product Type</label>
    <div class="col-sm-10">
      <nb-select id="selectProductType" fullWidth formControlName="productType">
        <nb-option *ngFor="let pt of productTypes$ | async" [value]="pt.id">{{ pt.name }}</nb-option>
      </nb-select>
    </div>
  </div>
  <div class="row">
    <label for="inputPicture" class="col-sm-2 col-form-label">Picture</label>
    <div class="col-sm-10">
      <input type="file" (change)="onImageUploadEvent.next($event)"
             [ngClass]="{'is-invalid':!productForm.get('image').valid}"
             [multiple]="false" id="inputPicture" accept="image/*">
      <image-cropper
        [imageChangedEvent]="onImageUploadEvent | async"
        [maintainAspectRatio]="true"
        [aspectRatio]="320 / 298"
        [resizeToWidth]="320"
        format="png"
        (imageCropped)="imageCropped($event)"
      ></image-cropper>
    </div>
  </div>
  <div class="row mb-3" *ngIf="productForm.get('image').value !== null">
    <label for="inputPicture" class="col-sm-2 col-form-label"></label>
    <div class="col-sm-10">
      <img style="max-width: 50%; background-color: #ffffff" [src]="productForm.get('image').value"/>
    </div>
  </div>
  <div class="form-group row">
    <label for="inputOrder" class="col-sm-2 col-form-label">Order</label>
    <div class="col-sm-10">
      <input type="number" nbInput fullWidth id="inputOrder" formControlName="order"
             [ngClass]="{'is-invalid':!productForm.get('order').valid}">
      <div class="invalid-feedback" *ngFor="let err of productForm.get('order').getError('backendErrors')">
        {{err}}
      </div>
    </div>
  </div>
  <div class="form-group row">
    <div class="col-sm-2">Product State</div>
    <div class="col-sm-10">
      <div class="form-check">
        <nb-checkbox id="checkLocked" formControlName="locked"></nb-checkbox>
        <label class="form-check-label" for="checkLocked">
          Locked
        </label>
      </div>
    </div>
  </div>


  <div class="row">
    <div class="col-sm-10">
      <button [disabled]="!productForm.valid"
              [status]="productForm.dirty && productForm.valid ? 'success' : 'danger'"
              type="submit" nbButton status="primary" (click)="save()">SAVE</button>
    </div>
  </div>
</form>
